#!/bin/sh

if  [ "$1" != "-d" ] || [ "$3" != "-w"  ] || [ "$2" == "" ] || [ "$2" == " " ]
then
      echo "usage: -d <Destination Dir> -w <Pattern String> <Grep parameters>"
      exit
fi

DSTDIR=$2
WORD=$4
GREPPARAM=$5
FILETMP="BACKUP_CP.DAT"

if [ ! -d $DSTDIR ]
then
   echo "Destination Dir   $DSTDIR   not found"
   exit
fi

echo "### WORD: $WORD ###" 

echo "######## FIND FILE ########"
for LFEXT in "*"  #"*.cc" "*.h" "*.tcl"
do

echo "-*------ $LFEXT ------*-"
find . -iname "$LFEXT"  -exec grep -H -n  $GREPPARAM "$WORD" '{}' ';' | awk 'BEGIN {FS=":"} {print $1}' | sort -u >> $FILETMP

done

echo "######## COPY FILE #########"
NUM=0
while read LINE
do
cp --parents  $LINE $DSTDIR
echo "File  $LINE  copied in  $DSTDIR"
NUM=$(($NUM+1))
done < $FILETMP

echo "$NUM files."
#echo "######### PRINT TMP FILE  #########"
#more $FILETMP
rm $FILETMP

echo ""
echo "######## CREATE TAR FILE ########"
tar -cvzf "$DSTDIR.tar.gz" $DSTDIR
