// HCF v3.0
#include <stdio.h>
#include "jitter.h"


JitterManager* JitterManager::instance;

JitterManager* JitterManager::getInstance()
{
	return (instance) ? instance : (instance = new JitterManager());
}


JitterManager::JitterManager()
{
	for(int i = 0; i < MAX_JITTERS; ++i)
		avg_delay[i] = -1.0;
}


void JitterManager::insertDelay(ulong jitter_id, ulong unique_id, double delay)
{
   pair<jittermap_it, bool> ret = delay_maps[jitter_id].insert(pair<ulong,double>(unique_id,delay));
	if (!ret.second)
		fprintf(stderr, "WARNING: trying to count the same packet twice while computing the jitter!\n");
}

double JitterManager::getAvgDelay(ulong jitter_id)
{
	if (!delay_maps[jitter_id].size())
		return 0.0;
	jittermap_it it = delay_maps[jitter_id].begin();

   avg_delay[jitter_id] == 0.0;
	while(it != delay_maps[jitter_id].end())
	{
		avg_delay[jitter_id] += it->second;
		++it;
	}
	return (avg_delay[jitter_id] /= delay_maps[jitter_id].size());
}

double JitterManager::getJitter(ulong jitter_id)
{
	if (!delay_maps[jitter_id].size())
		return 0.0;
	if (avg_delay[jitter_id] < 0)
		getAvgDelay(jitter_id);

	jittermap_it it = delay_maps[jitter_id].begin();
	double diff, jitter = 0.0;

	while(it != delay_maps[jitter_id].end())
	{
		diff = avg_delay[jitter_id] - it->second;
		diff *= diff;
		jitter += diff;
		++it;
	}
	return (jitter/(delay_maps[jitter_id].size()-1));
}

void JitterManager::reset(ulong jitter_id)
{
	delay_maps[jitter_id].clear();
	avg_delay[jitter_id] = -1.0;
}
