
proc open_stat_files {} {
    global opt dd_filed ud_filed ab_filed dj_filed dad_filed uj_filed uad_filed fair_filed
    #set dd_filed [open "drop_down.txt" $opt(appORwrt)]
    set ud_filed [open "drop_up.txt" $opt(appORwrt)]
    #set ab_filed [open "avg_buff.txt" $opt(appORwrt)]
    set dj_filed [open "jitter_down.txt" $opt(appORwrt)]
    set dad_filed [open "avg_delay_down.txt" $opt(appORwrt)]
    set uj_filed [open "jitter_up.txt" $opt(appORwrt)]
    set uad_filed [open "avg_delay_up.txt" $opt(appORwrt)]
    set fair_filed [open "fairness.txt" $opt(appORwrt)]
}

proc close_stat_files {} {
    global dd_filed ud_filed ab_filed dj_filed dad_filed uj_filed uad_filed fair_filed
    #close $dd_filed
    close $ud_filed
    #close $ab_filed
    close $dj_filed
    close $dad_filed
    close $uj_filed
    close $uad_filed
    close $fair_filed
}


proc stats {num} {
    global dd_filed ud_filed ab_filed dj_filed dad_filed uj_filed uad_filed fair_filed
    #dDROP_stat $num $dd_filed
    uDROP_stat $num $ud_filed
    fairness_stat $num $fair_filed
    #AVGBUFF_stat $num $ab_filed
    JITTER_stat $num $dj_filed $dad_filed $uj_filed $uad_filed
}

# Init global statistics variable
set prev_dpkt_sent 0
set prev_dpkt_drop 0
set prev_upkt_sent 0
set prev_upkt_drop 0

#
# Print to file the ratio of the number of dropped packets to the number of sent packets (downlink)
#
proc dDROP_stat {num filed} {
    global udp_down prev_dpkt_sent prev_dpkt_drop obj

    set pkt_sent 0
    for {set i 1} {$i <= $num} {incr i} {
         set pkt_sent [expr $pkt_sent + [$udp_down($i) set seqno_]]
    }

    set pkt_sent [expr $pkt_sent - $prev_dpkt_sent ]
    set prev_dpkt_sent [expr $prev_dpkt_sent + $pkt_sent]
    
    set tot_pkt_drop [BS_udp_pkt_drop]
    set pkt_drop [expr $tot_pkt_drop - $prev_dpkt_drop]
    set prev_dpkt_drop $tot_pkt_drop

    #puts $filed "$num   $pkt_sent  $pkt_drop   [expr $pkt_drop.0/$pkt_sent.0]"
    puts $filed "$num    [expr $pkt_drop.0/$pkt_sent.0]"
}

#
# Print to file the ratio of the number of dropped packets to the number of sent packets (uplink)
#
proc uDROP_stat {num filed} {
    global udp_up prev_upkt_sent prev_upkt_drop obj

    set pkt_sent 0
    for {set i 1} {$i <= $num} {incr i} {
         set pkt_sent [expr $pkt_sent + [$udp_up($i) set seqno_]]
    }

    set pkt_sent [expr $pkt_sent - $prev_upkt_sent]
    set prev_upkt_sent [expr $prev_upkt_sent + $pkt_sent]

    set tot_pkt_drop [WN_udp_pkt_drop $num]
    set pkt_drop [expr $tot_pkt_drop - $prev_upkt_drop]
    set prev_upkt_drop $tot_pkt_drop
    
    #puts $filed "$num   $pkt_sent  $pkt_drop   [expr $pkt_drop.0/$pkt_sent.0]"
    puts $filed "$num    [expr $pkt_drop.0/$pkt_sent.0]"
    puts "uDrop:         $pkt_sent         $pkt_drop"
}

#
# Print to file the ratio of the number of dropped packets to the number of sent packets (uplink)
#
proc fairness_stat {num filed} {
    global curr_queue_stat opt num_n obj udp_up
    set drop_max 0.0
    set drop_min 1.0
    set drop_avg 0.0

    for {set i 1} {$i <= $num} {incr i} {
      $obj(ifq,$i) cmd dump_queue;# getting info from wireless-node queues (calling C++ method)
      set drop [expr ($curr_queue_stat(ifq,drop,2,udp).0 + $curr_queue_stat(ifq,tout,2,udp).0)/[$udp_up($i) set seqno_]]
      if {$drop > $drop_max} {
         set drop_max $drop
      }
      if {$drop < $drop_min} {
         set drop_min $drop               
      }
      set drop_avg [expr $drop_avg + $drop]
    }
    set drop_avg [expr $drop_avg/$num]

    puts "MIN-MAX-AVG:    $drop_min $drop_max $drop_avg"
    #puts  $filed "$num    $drop_min      $drop_max      $drop_avg"
    puts  $filed "    $drop_min      $drop_max      $drop_avg"
}


#
# prints the avg buffer size of the BS
#
proc AVGBUFF_stat {num filed} {
      global obj curr_queue_stat prev_avg_buff
      $obj(ifq,0) cmd dump_avg_size             ;# calling C++ method for getting the avg_size
      puts $filed "$num  $curr_queue_stat(ifq,avg_size,2)"
      $obj(ifq,0) cmd reset_avg_size             ;# calling C++ method for resetting avg_size counting
}

#
# prints avg_delay and buffer statistics
#
proc JITTER_stat {num dj_filed dad_filed uj_filed uad_filed} {
    global ns_
    # uncomment to get downlink statistics
    #set avg_delay_down [$ns_ get-avgdelay 1]
    #set jitter_down [$ns_ get-jitter 1]
    set avg_delay_up [$ns_ get-avgdelay 2]
    set jitter_up [$ns_ get-jitter 2]
    #puts "AvgDelay: $avg_delay_down      Jitter: $jitter_down"
    puts "AvgDelay: $avg_delay_up      Jitter: $jitter_up"
    #puts $dj_filed "$num   $jitter_down"
    #puts $dad_filed "$num    $avg_delay_down"
    puts $uj_filed "$num   $jitter_up"
    puts $uad_filed "$num    $avg_delay_up"
    #$ns_ reset-jitter 1
    $ns_ reset-jitter 2

}

proc BS_udp_pkt_drop {} {
        global curr_queue_stat obj
        $obj(ifq,0) cmd dump_queue         ;# getting info from BS queues (calling C++ method)
        set total_drop [expr $curr_queue_stat(ifq,drop,2,udp) + $curr_queue_stat(ifq,tout,2,udp)]
        return $total_drop
}

proc WN_udp_pkt_drop {num} {
        global curr_queue_stat opt obj udp_up
        set total_drop 0
        for {set i 1} {$i <= $num} {incr i} {
             $obj(ifq,$i) cmd dump_queue;# getting info from wireless-node queues (calling C++ method)
             puts "drop:  $curr_queue_stat(ifq,drop,2,udp)    tout:  $curr_queue_stat(ifq,tout,2,udp)"
             set total_drop [expr $total_drop + $curr_queue_stat(ifq,drop,2,udp) + $curr_queue_stat(ifq,tout,2,udp)]
        }
        return $total_drop 
}



######################################################################
#                                                                    #
# queue_stat: called by drop-tail.cc to dump Interface Queue           #
#           statistics                                               #
#                                                                    #
#                n: queue identifier                                 #
#           q_arrv: total number of packet arrival                   #
#           q_size: average queue size                               #
#            rcv_*: packets received from the LLC                    #
#           drop_*: packets discarded due to saturation              #
#                                                                    #
#           * rapresents the packet type                             #
#                                                                    #
######################################################################

proc queue_stat {n limit q_arrv q_size rcv_tcp rcv_ack rcv_message rcv_ARP rcv_udp rcv_voip \
                drop_tcp drop_ack drop_message drop_ARP drop_udp drop_voip \
                tout_tcp tout_ack tout_message tout_ARP tout_udp tout_voip} {
        global curr_queue_stat
        set curr_queue_stat(bs_q_size,$n) $q_size
        set curr_queue_stat(bs_q_arrv,$n) $q_arrv
        set curr_queue_stat(bs_q_limit,$n) $limit
        foreach tip {rcv drop tout} {
                foreach typ {ARP message ack tcp udp voip} {
                        set curr_queue_stat(ifq,$tip,$n,$typ) [set $tip\_$typ]
                }
        }
}

########################################################################################
#                                                                                      #
#  queue_avgsize: called by c++ class BS_DropTail (see queue/drop-tail.cc) to dump     #
#                 the average queue size.                                              #
#  note: the avg counting is resetted                                                  #
#                                                                                      #
########################################################################################

proc queue_avgsize {n avg_size} {
      global curr_queue_stat
      puts "$n -> $avg_size"
      set curr_queue_stat(ifq,avg_size,$n) $avg_size
}